/* returns: 0 if X wins
 *          1 if O wins
 *          2 if tie
 *          3 keep playing
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

//initially based on Frank's code

int K; 

char
check_win(char *board){
    int i,j;
    char h;
    bool failed;
    // check all the rows
    for(i=0; i<K; i++)  {
      failed = false;
      h = board[i * K];  
      j = 0;
      while(!failed && j<K){
	if(board[i*K + j] != h)
	  failed = true;
	j++;
      }
      if(!failed && h!='_'){
	return h;
      }
    }

    // check all the columns
    for(i=0; i<K; i++)  {
      failed = false;
      h = board[i];
      j = 0;
      while(!failed && j<K){
	if(board[i+j*K] != h)
	  failed = true;
	j++;
      }
      if(!failed && h!='_'){
	return h;
      }
    }
    //first diagonal
    failed = false;
    h = board[0];
    j = 0;
    while(!failed && j<K){
      if(board[j+j*K] != h)
	failed = true;
      j++;
    }
    if(!failed && h!= '_'){
      return h;
    }

    //second diagoal
    failed = false;
    h = board[K-1];
    j = 1;
    while(!failed && j<=K){
      if(board[j*K - j] != h)
	failed = true;
      j++;
    }
    if(!failed && h != '_'){
      return h;
    }
    //if we got here, no body has won yet. Is table full?
    failed = false;
    j = 0;
    while(!failed && j < K*K){
      if(board[j]  == '_')
	failed = true;
      j++;
    }
    if(!failed){
      //board full
      return 'F';
    }
    else return 'N';//keep playin

    return 0;
}

int main(int argc, char*argv[]){

  K = atoi(argv[1]);
  char* board = new char[K*K];
  memset(board, 0, K*K*sizeof(char));
  FILE* f = fopen("b.txt", "rt");
  int i = 0;
  while (!feof(f) && i < K*K){
    fscanf(f, "%c", &board[i]);
    i++;
  }
  char r  = check_win(board);
  if(r=='X' || r=='x')
    printf("%d\n", 0);
  if(r=='O' || r=='o')
    printf("%d\n", 1);
  if(r=='F')
    printf("%d\n", 2);
  if(r=='N')
    printf("%d\n", 3);
  delete [] board;
  exit(0);
}

