//Function:
//	Read move and board. Verify whether the move is correct 
//	If it is, update the board. Check win, lose or draw.
//Input: size, a move and ture(0:X, 1:Y)
//Output: 0: X won. 1: O won. 2: draw. 3: invalid move. 5: game is not done.

#include <stdio.h>

int print_ver = 1;
int size=10;
char board[100][100];
int empty_num ;
int n;

int read_board();
int write_board();
void print_board(); 
int Won(int, int, char);


int main(int argc, char* argv[])
{
	int move = atoi(argv[2]);
	size = atoi(argv[1]);
	int turn = atoi(argv[3]);//turn =0 X; turn =1 O;
	
	int correct;
	int result;
	int row,col;
	
	read_board();	
	//print_board(); 
		
	n = size/2;
	row = move / size;
	col = move % size;
	//fprintf(stderr, "Size:%d; $Move:%d= (%d,%d)\n",size,move,row,col);	
	
	
	if(board[row][col] != '_') result = 3; //invalid move
	else{
		if(turn ==0){	
			board[row][col] = 'X';
			
			if(Won(row,col,'X')){
				result = 0;
			}
			else if(empty_num <= 1){				
				result = 2;//draw
			}
			else{
				result = 5;//
			}							
		}
		else{
			board[row][col] = 'O';
			if(Won(row,col,'O')){
				result = 1;
			}
			else if(empty_num <= 1){				
				result = 2;//draw
			}
			else{
				result = 5;//
			}
		}
		
		
		
		
	}
	

	//update board.txt
	write_board();	
	//print_board();

	
	//print the result, 0 Xwon; 1 Owon; 2 draw; 5 don't know yet
	printf("%d\n",result);

}

void initial_board()
{
	int i,j;
	for(i=0;i<100;i++)
		for(j=0;j<100;j++)
			board[i][j] = '_';			
}

int read_board()
{
	FILE *fid; 	
	int row, col;
	int c_mark;
	

	initial_board();
	empty_num = 0;
	
	if( (fid = fopen("board.txt", "r")) == NULL ){
		fprintf(stderr,"No such file: board.txt\n");
		exit(0);
	}
	for(row=0;row<size;row++){
		for(col=0;col<size;col++){
			if( (c_mark = fgetc(fid)) != EOF){								
				board[row][col] = c_mark;																
				
				if(c_mark == '_'){
					empty_num++;
				}
				
			}	
			
		}
	}			
	fclose(fid);
	
	return(1);
}

int Won(int i, int j, char mark)
{
			
	int flag;
	int low_num,high_num;
	int x_pos,y_pos;	
	
	//(1) check row			
	flag = 0; y_pos = j-1;
	while(y_pos >= 0 && !flag){
		if(board[i][y_pos] != mark){
			flag = 1;
		}
		else y_pos--;		
	}
	low_num = j-y_pos-1;
		
	flag = 0; y_pos = j+1;
	while(y_pos < size && !flag){
		if(board[i][y_pos] != mark){
			flag = 1;
		}		
		else y_pos++;
	}
	high_num = y_pos-j-1;
			
	if(low_num+high_num+1 >= n) return(1);	
	
	//(2)check column		
	flag = 0; x_pos = i-1;
	while(x_pos >=0 && !flag){
		if(board[x_pos][j] != mark){
			flag = 1;
		}		
		else x_pos--;
	}
	low_num = i-x_pos-1;
	
	
	flag = 0; x_pos = i+1;
	while(x_pos < size && !flag){
		if(board[x_pos][j] != mark){
			flag = 1;
		}
		else x_pos++;		
	}
	high_num = x_pos-i-1;
		
	if(low_num+high_num+1 >= n) return(1);	
	
	//(3)check first diagonal	
	flag = 0; x_pos = i-1;y_pos=j-1;
	while(x_pos >=0 && y_pos >=0 && !flag){
		if(board[x_pos][y_pos] != mark){
			flag = 1;
		}
		else{	
			x_pos--;
			y_pos--;
		}
	}
	low_num = i-x_pos-1;
	
	flag = 0; x_pos = i+1;y_pos=j+1;
	while(x_pos <size && y_pos <size && !flag){
		if(board[x_pos][y_pos] != mark){
			flag = 1;
		}
		else{	
			x_pos++;
			y_pos++;
		}
	}			
	high_num = x_pos-i-1;
	
	if(low_num+high_num+1 >= n) return(1);	
	
	//(4)check second diagonal
	flag = 0; x_pos = i+1;y_pos=j-1;
	while(x_pos <size && y_pos >=0 && !flag){
		if(board[x_pos][y_pos] != mark){
			flag = 1;
		}
		else{	
			x_pos++;
			y_pos--;
		}
	}
	low_num = j-y_pos-1;
	
	flag = 0; x_pos = i-1;y_pos=j+1;
	while(x_pos >=0 && y_pos <size && !flag){
		if(board[x_pos][y_pos] != mark){
			flag = 1;
		}
		else{	
			x_pos--;
			y_pos++;
		}
	}			
	high_num = y_pos-j-1;
	
	if(low_num+high_num+1 >= n) return(1);	
	
	return 0;
}

int write_board()
{
	FILE *fid; 	
	int row, col;
	int c_mark;

	if( (fid = fopen("board.txt", "w")) == NULL ){
		fprintf(stderr,"No such file: board.txt\n");
		exit(0);
	}
	for(row=0;row<size;row++){
		for(col=0;col<size;col++){	
			fprintf(fid,"%c",board[row][col]);
		}
	}
		
	fclose(fid);
	return(1);
}

//for test only
void print_board() 
{
	int row, col;
	for(row=0;row<size;row++){		
		if(print_ver == 1) fprintf(stderr,"%d  ",row);
		for(col=0;col<size;col++){
			fprintf(stderr,"%c ",board[row][col]);		
		}
		fprintf(stderr,"\n");
	}			
	
	if(print_ver == 1){
		fprintf(stderr,"   ");
		for(col=0;col<size;col++){
			fprintf(stderr,"%d ",col);
		}
		fprintf(stderr,"\n");
	}
}
