
#include <stdio.h>
#include <time.h>

int print_ver = 1;
int method = 1;

int read_board();
void print_board();
int player();
void gen_empty();
int neighbor_IsNotEmpty(int,int);

int size = 10;//default size
char board[100][100];
int empty[10000];
int empty_num;

int main(int argc, char* argv[])
{	
	int result;
	int res_row, res_col;
	

	//Read size (k) from stdin
	//fprintf(stderr,"Please input the size (k) of the board:");
	scanf("%d", &size);
	if(size > 100)
	{ 
		fprintf(stderr,"The size must be less than 100\n") ;
		exit(0);
	}
	
	//fprintf(stderr,"The size of the board is : %d\n", size);
			
	//Read board from board.txt
	if( read_board()){
		//print_board();		
		
		gen_empty();
		result = player();
	
		//print the X player's move to standard output
		printf("%d\n",result);		
	}
	else{
		fprintf(stderr,"Error: Loading board failed\n");
	}
	
	
	
}

void initial_board()
{
	int i,j;
	for(i=0;i<100;i++)
		for(j=0;j<100;j++)
			board[i][j] = '_';			
}

int read_board()
{
	FILE *fid; 	
	int row, col;
	int c_mark;
		
	initial_board();
	
	if( (fid = fopen("board.txt", "r")) == NULL ){
		fprintf(stderr,"No such file: board.txt\n");
		exit(0);
	}
	for(row=0;row<size;row++){
		for(col=0;col<size;col++){
			if( (c_mark = fgetc(fid)) != EOF){								
				board[row][col] = c_mark;																
			}					
		}
	}			
	fclose(fid);
	
	return(1);
}

void gen_empty()
{
	int row,col;
	empty_num = 0;
	for(row=0;row<size;row++){
		for(col=0;col<size;col++){
			if(method == 1){
				if(board[row][col] == '_' && neighbor_IsNotEmpty(row,col)){
					empty[empty_num] = row*size+col;
					empty_num++;
				}
			}
			else{
				if(board[row][col] == '_'){											
					empty[empty_num] = row*size+col;
					empty_num++;
				}
			}
		}
	}
}


//for test only
void print_board() 
{
	int row, col;
	for(row=0;row<size;row++){		
		if(print_ver == 1) fprintf(stderr,"%d  ",row);
		for(col=0;col<size;col++){
			fprintf(stderr,"%c ",board[row][col]);		
		}
		fprintf(stderr,"\n");
	}			
	
	if(print_ver == 1){
		fprintf(stderr,"   ");
		for(col=0;col<size;col++){
			fprintf(stderr,"%d ",col);
		}
		fprintf(stderr,"\n");
	}
}

//Random choose an empty cell
int player()
{
	int empty_ind;
	
	if(empty_num==0 && method ==1) return ( size*size/2);
	
	srand(time(NULL));	
	empty_ind = rand() % empty_num;
	return(empty[empty_ind]);
	
}

//
int neighbor_IsNotEmpty(int row,int col)
{
	if(  row > 0 	&& col > 0 	&& board[row-1][col-1] != '_'){ return(1);}
	if(  row > 0 			&& board[row-1][col] != '_'){ return(1);}
	if(  row > 0 	&& col+1<size 	&& board[row-1][col+1] != '_'){ return(1);}
	if(    		col > 0 	&& board[row][col-1] != '_'){ return(1);}	
	
	if(     	col+1<size 	&& board[row][col+1] != '_'){ return(1);}
	if(  row+1<size &&   col > 0 	&& board[row+1][col-1] != '_'){ return(1);}
	if(  row+1<size 		&&   board[row+1][col] != '_'){ return(1);}
	if(  row+1<size &&   col+1<size && board[row+1][col+1] != '_'){ return(1);}
	
	return(0);
	
}
